// TestBoostThread.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"

using namespace std;

boost::recursive_mutex theMutex;

typedef std::list<boost::condition*> Conditions;
Conditions theConditions;


void ThreadFuncWaiter()
{	
	boost::condition con1;
	for(;;)
	{	

		boost::recursive_mutex::scoped_lock lockMtx(theMutex);
		theConditions.push_back(&con1);
	
		if (con1.timed_wait(lockMtx, boost::posix_time::time_duration(0,0,50)))
		{
			cout << "Woke Up " << GetCurrentThreadId() << endl;
		}
		else
		{
			cout << "*****Timed Out " << GetCurrentThreadId() << endl;
			exit(13);
		}
		
		theConditions.remove(&con1);
		
		Sleep(2000);
	}
}

void ThreadFuncNotifier()
{	
	for(;;)
	{
		boost::recursive_mutex::scoped_lock lockMtx(theMutex);

		unsigned int i = 0;
		for (Conditions::iterator it = theConditions.begin(); 
			it != theConditions.end() && i < 2; 
			++it)
		{			
			(*it)->notify_one();
			//WORKAROUND_ lockMtx.unlock();
			//WORKAROUND_ Sleep(50);
			cout << "Notified One " << theConditions.size() << endl;
			++i; 
			//WORKAROUND_ lockMtx.lock();
		}
		
		Sleep(500);
	}
}


int main(int /*argc*/, char* /*argv[]*/)
{
	boost::thread_group tg;
	for (int i = 0; i < 12; ++i)
	{
		tg.create_thread(ThreadFuncWaiter);
	}

	tg.create_thread(ThreadFuncNotifier);

	tg.join_all();


	return 0;
}

